#include <stdio.h>
#include <math.h>
#define nb  65536
#define p60  60                // using A73 cali, adjust in nqz_9 rlready
#define f99   199
FILE *fp[f99],*fp1,*fp2;
char h[72][80];
float a[16000*16000];
char c[16000*16000];         // 20120514
float b[f99][nb];
char  name[f99][12];
char  d[60],f1[40];
float sky[f99],flu[f99],white;
double addsky,ss;
double addgain;
int n1,n2,m;

float dd[f99],saa[f99],gain[f99],thr;
float s61=6.;
float s62=6.;
int SCALE,it=0,AUTOBAL=0;

float xmedian(a,m)
float *a; int m;
{
  int i,j; float x;
  for(i=0;i<m-1;i++)for(j=i+1;j<m;j++)if(a[i]<a[j]){
    x=a[i]; a[i]=a[j]; a[j]=x;
  }
  j=m/2; x=a[j];
  if(m%2==0)x=(a[j-1]+a[j])*0.5;
  return(x);
}

main(int ac,char **av)
{
  int i,j,k,jj,kk,l,ip=0;
  double xx,yy;
  float scale,wsky,adjsky;
  char t[80];
  if(ac<3){
    printf("\n\t******* combine q*.fit (from nqz6_9),A73 ***********\n");
    printf("\n\t\t\t        20130313\n");
    printf("\n\tUsage: qcomb6 batchfile outfits [1min,2nd]");
    printf("\n\t       qcomb6 qz_6.tmp aa.fit\n"); 
    printf("\n\t you can edit qz_6.tmp");
    printf("\n\t append a sky_adjust_value at line_end");
    printf("\n\t ex: q5724_0122_1.fit -4.5\n");
    printf("\n\t if scale=0.454, then");
    printf("\n\t   do c9a73");
    printf("\n\t   append BG_*, for look only");
    printf("\n\t   append b_*, for SEX select star");
    printf("\n\t else");
    printf("\n\t   smooth0\n");
    printf("\n\t 1min: sky=min(p_sky,n_sky)");
    printf("\n\t 2nd: sky=2nd_sky\n\n");
    exit(0);
  }
  if(ac>3){ it=av[3][0]-48; if(it>2)it=0; }
  fp2=fopen("qz_6.txt","w");
  fp1=fopen(av[1],"r");
  if(fp1==0){ printf("%s not found!\n",av[1]); exit(0); }
l10:
  fgets(d,60,fp1); if(feof(fp1))goto l20;
  if(d[0]=='#')goto l10;
  for(k=0;k<strlen(d);k++)if(d[k]<=32)break;
  if(strlen(d)>k+1)sscanf(&d[k+1],"%f",&adjsky); else adjsky=0.;
//printf("%d %d %f\n",k,strlen(d),adjsky);
  d[k]=0;
  fp[ip]=fopen(d,"rb");
  fread(h,72,80,fp[ip]);
  sscanf(&h[3][12],"%d",&n1);
  sscanf(&h[4][12],"%d",&n2);
  sscanf(&h[p60][70],"%f",&flu[ip]);  if(flu[ip]<0.)flu[ip]=-flu[ip];
  sscanf(&h[32][12],"%f",&sky[ip]);
           if(flu[ip]==0)flu[ip]=sky[ip]*0.005;
  d[12]=0;  strcpy(name[ip],&d[1]);
// read gain
  sscanf(&h[31][10],"%f %f %f %f",&saa[0],&saa[1],&saa[2],&saa[3]);
  thr=0.; for(i=0;i<4;i++)thr+=saa[i]; gain[ip]=thr*.25;
  k=indexpos(h,"SCALE   ",72);  
  if(k!=72)sscanf(&h[k][20],"%f",&scale);
  SCALE=scale*1000.+0.5;
  if(n1==8640 && n2==8200 && SCALE==454)AUTOBAL=1;
  if(AUTOBAL){
//    calsky(a,n1,n2,&wsky,fp[ip],it);
//sprintf(t,"%2d %s.fit: sky%7.1f cal:%7.1f+%4.1f",ip+1,d,sky[ip],wsky,adjsky); 
  sprintf(t,"%2d %s.fit: sky%7.1f %4.1f",ip+1,d,sky[ip],adjsky); 
  }
  if(it==0)sky[ip]+=adjsky;
  if(it){
    if(wsky==0.)wsky=sky[ip];
    if(it==1)if(wsky>sky[ip])wsky=sky[ip];
    sky[ip]=wsky+adjsky;
  }
  if(AUTOBAL)
  printf("%s --> %7.1f\n",t,sky[ip]); fprintf(fp2,"%s --> %7.1f\n",t,sky[ip]);
  
  if(++ip!=f99) goto l10;
    else printf(" only < %d files canbe combine !\n",f99); 
l20:
  fclose(fp1);  fclose(fp2);

  if(it==0)printf("=== use p*.fit's sky ===\n");
  if(it==1)printf("=== use min sky ===\n");
  if(it==2)printf("=== use cal 2nd_sky ===\n");

for(i=0;i<ip;i++)printf("%2d sky %f w: %f\n",i+1,sky[i],flu[i]);
/*
        do 216 i=1,m
        dd(i)=sqrt(white(i)/g(i))
216     s(i)=s62*dd(i)/scale(i)
        sigma=xmedian(dd,m)
*/
  for(i=0;i<ip;i++){
    dd[i] =sqrt(sky[i]/gain[i]);
    saa[i]=s62*dd[i]/flu[i];
  } thr=xmedian(dd,ip);

//  printf("%d files, %d*%d  thresh:%f\n",ip,n1,n2,thr);
  printf("%d files, %d*%d\n",ip,n1,n2);

  m=n1*n2;  j=jj=0; addsky=ss=0.;
                    addgain=0.;
  for(i=0;i<m;i++)a[i]=-9999.;
l30:
  k=m-j; if(k>nb)k=nb; if(k<=0)goto l40;
  if(jj%10==0){ printf("."); fflush(stdout); }
//  printf("%d %d\n",j,k); 
  for(kk=0;kk<ip;kk++){ fread(b[kk],4,nb,fp[kk]); swap4(b[kk],4*nb); }
  for(i=0;i<k;i++){
//allc(d[],white[],scale[],m,sigma,s[],s61,s50,g[])
//     dd  sky     flu    ip  thr  saa    6    gain
    for(kk=0;kk<ip;kk++)dd[kk]=b[kk][i];
    c[i+j]=allc(dd,sky,flu,ip,thr,saa,s61,gain);     // if delete, dd[]=0;
 
    xx=yy=0.;
    for(kk=0;kk<ip;kk++)if(dd[kk]!=0.){
      xx+=dd[kk]-sky[kk];      yy+=flu[kk];
      addsky+=sky[kk]*flu[kk]; ss+=flu[kk];
      addgain+=gain[kk]*flu[kk];
    }
    if(yy!=0.)a[j+i]=xx/yy;
  }
  j+=k; jj++;
  goto l30;
l40:
  for(i=0;i<ip;i++)fclose(fp[i]);
  white=addsky/ss;
  thr=addgain/ss;                              // average gain
  printf("new_sky: %f  gain: %f\n",white,thr);
  sprintf(&h[32][0],"SKYADU  =         %12.3f ",white);  h[32][31]='/';
                    for(i= 0;i<80;i++)h[7][i]=32;
                    for(i=10;i<30;i++)h[9][i]=32;
  for(j=30;j<32;j++)for(i= 0;i<80;i++)h[j][i]=32;
  for(j=32;j<34;j++)for(i=50;i<80;i++)h[j][i]=32;
  for(i=0;i<m;i++){ if(a[i]==-9999.)a[i]=0.; else a[i]+=white; }
  for(k=0;k<ip;k++){
    i=(k/4)+1; j=(k%4)*12+32;
    for(l=0;l<11;l++)h[i][j+l]=name[k][l]; h[i][j+l]=32;
  }
  sprintf(&h[0][31],"/ total files:%4d (de_cosmos)",ip);
  h[0][61]=32;

  sscanf(name[0],"%d",&l);
  jd2date(l+1,&i,&j,&k);
  sprintf(h[8], "DATE-OBS=%4d,%02d,%02d ",i,j,k); 
  sscanf(name[ip-1],"%d",&l);
  jd2date(l+1,&i,&j,&k); sprintf(&h[8][20],"~%4d,%02d,%02d",i,j,k);
  h[8][31]='/';
  for(i=0;i<80;i++)h[29][i]=32;
  for(j=59;j<=65;j++)for(i=0;i<80;i++)h[j][i]=32;
  strcpy(f1,av[2]);
  fp1=fopen(f1,"wb");  fwrite(h,72,80,fp1);
  swap4(a,m*4); fwrite(a,m,4,fp1);  fclose(fp1);
  printf("output: %s  scale: %8.4f\n",f1,scale);
  if(SCALE!=454 || AUTOBAL==0)exit(0);
  sprintf(d,"c9a73 %s g",f1); system(d);
//         sprintf(d,"c94 %s",f1); system(d);    // force CALI =4.000   20120815
// write down differ BG fit.  
/*
  sprintf(f1,"BG_%s",av[2]);
  swap4(a,m*4); for(i=0;i<m;i++)if(a[i]!=0.) a[i]+=(c[i]-2)*5; 
  fp1=fopen(f1,"wb");  fwrite(h,72,80,fp1);
  swap4(a,m*4); fwrite(a,m,4,fp1);  fclose(fp1);
  printf("***Appended output: %s for a look only !!!\n",f1);
*/
  sprintf(f1,"b_%s",av[2]);
  strcpy(&h[1][0], "BITPIX  =                    8 ");  h[1][31]=32;
  fp1=fopen(f1,"wb");  fwrite(h,72,80,fp1);
  fwrite(c,m,1,fp1);  fclose(fp1);
  printf("***Appended output: %s for SEX select star !!\n",f1);
}

#define ij 256
short ds[512*512];
calsky(a,n1,n2,sky,fp,it)
float a[n2][n1],*sky; int n1,n2,it; FILE *fp;
// cal 16 skys;
// if none,      out sky=0;
// if 1          out sky
// if 2          sky=(sky1+sky2)/2
// if 4 or 3     sky= 2nd_sky
{
  int i,j,k,ii,jj,i1,j1,kk=0; float x,s,d[16];
  fread(a,n1*n2,4,fp); swap4(a,n1*n2*4); fseek(fp,72*80,0);
  for(j=0;j<4;j++)for(i=0;i<4;i++){  x=0.;
    k=0; i1=n1/8*(i*2+1); j1=n2/8*(j*2+1);
    for(jj=j1-ij;jj<j1+ij;jj++)for(ii=i1-ij;ii<i1+ij;ii++)
    if(a[jj][ii]>9. && a[jj][ii]<32000.)ds[k++]=a[jj][ii];
    if(k>512*128)white_black(ds,1,k,&x,&s);
    d[kk++]=x;
  }
//  for(i=0;i<16;i++)if(d[i]!=0.)printf("%f ",d[i]); printf("\n");
  for(i=k=0;i<16;i++)if(d[i]!=0.)d[k++]=d[i];
  if(k==0)*sky=0.;
  if(k==1)*sky=d[0];
  if(k==2){ *sky=(d[0]+d[1])*0.5; if(it==1)*sky=d[0]>d[1]?d[1]:d[0]; }
  if(k>2){
    for(i=0;i<k-1;i++)for(j=i+1;j<k;j++)if(d[i]>d[j]){
      x=d[i]; d[i]=d[j]; d[j]=x;  
    }
    *sky=d[1]; if(it==1)*sky=d[0];
  }
}

/*
calsky(a,n1,n2,sky,fp)
float a[n2][n1],*sky; int n1,n2; FILE *fp;
{ 
  int i,j,k,ii,jj,i2,j2; float s,t,r=99999.;
  fread(a,n1*n2,4,fp); swap4(a,n1*n2*4); fseek(fp,72*80,0);
  for(jj=0;jj<n2;jj+=step)for(ii=0;ii<n1;ii+=step){ k=0;
    j2=jj+step; if(j2>n2)j2=n2;
    i2=ii+step; if(i2>n1)i2=n1;
    for(j=jj;j<j2;j++)for(i=ii;i<i2;i++)if(a[j][i]>0. && a[j][i]<32000.){
      ds[k++]=a[j][i]; 
    } if(k>3000)white_black(ds,1,k,&s,&t); else continue;   
//    printf("%7.1f",s); 
    if(s<r)r=s;
  } *sky=r; 
}
*/

allc(dd,sky,flu,ip,thr,saa,s61,gain)     // if delete, dd[]=0;
float *dd,*sky,*flu,thr,*saa,s61,*gain;
int   ip;
{
  int i,j,k,u[f99];
  float d1[f99],d2[f99],x;
// delete bad & moveto
  for(i=k=0;i<ip;i++)if(dd[i]!=0.){
    if(dd[i]<sky[i]/2.)dd[i]=0.;           // delete dead point
    else { d2[k]=d1[k]=(dd[i]-sky[i])/flu[i]; u[k++]=i; }
  }
  if(k<3)return(k);                           // not enough
  x=xmedian(d2,k);
  if(x>thr){                 // star
    if(d2[0]<s61*x)return(k);
    for(i=0;i<k;i++)if(d1[i]==d2[0])dd[u[i]]=0.;  
  } else  {                  // background
    for(i=0;i<k;i++)
    if(d1[i]==d2[0] && d1[i]>saa[u[i]])dd[u[i]]=0.;
  }
  return(k);
}

/*
        do 20 i=1,m
20      if(d(i).gt.bad)d1(i)=(d(i)-white(i))/scale(i)  !ne
...
100     do 110 i=1,m
110     d2(i)=d1(i)
        x=xmedian(d2,m)
        if(x.gt.sigma)then              ! star
          if(d2(1).lt.s61*x)goto 200
          do 120 i=1,m
120       if(d1(i).eq.d2(1))d1(i)=x
        else                            ! background
          do 130 i=1,m
130       if( d1(i).eq.d2(1) .and. d1(i).gt.s(i) )d1(i)=x
        endif
*/

int mon[12]={31,28,31,30,31,30,31,31,30,31,30,31};
jd2date(int jd4,int *y,int *m,int *d)
{
  int iy,im,id,k;
  k=jd4; if(k<9354)k+=10000;
  for(iy=1994;iy<=2021;iy++){
    mon[1]=28; if(iy%4==0)mon[1]=29;
    for(im=0;im<12;im++)for(id=1;id<=mon[im];id++){
      if(k==jd2(iy,im+1,id)){ im++;
//        printf("%d ---> %02d %02d %02d\n",k-10000,iy,im,id);
        *y=iy; *m=im; *d=id; return;
      }
    }
  }
}

jd2(int year,int im,int id)
{
  int i,j,iy=year-1900;
  i=(im+9)*0.09; i=(i+iy)*1.75+0.01;
  j=30.56*im;  j=(iy-50)*367+id+j-i;
  return(j-6661);
}
